

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> // include processor files - each processor file is guarded.  
#include <string.h>
#include <stdlib.h>

#define _XTAL_FREQ	4000000         //  

#define FOUR_BIT_MODE  
#define Nop()				asm("nop")

//  
    #define LCD_RS_TRIS			(TRISB4)
	#define LCD_RS_IO			(RB4)
	#define LCD_E_TRIS			(TRISB5)
	#define LCD_E_IO			(RB5)
    #define LCD_DATA0_TRIS      (TRISB0)
    #define LCD_DATA0_IO       	(RB0)
    #define LCD_DATA1_TRIS      (TRISB1)
    #define LCD_DATA1_IO       	(RB1)
    #define LCD_DATA2_TRIS      (TRISB2)
    #define LCD_DATA2_IO       	(RB2)
    #define LCD_DATA3_TRIS      (TRISB3)
    #define LCD_DATA3_IO       	(RB3)


// LCDText is a 32 byte shadow of the LCD text.  Write to it and 
// then call LCDUpdate() to copy the string into the LCD module.
unsigned char LCDText[16*2+1];
typedef unsigned char BYTE; 


void LCDWrite(BYTE RS, BYTE Data);
void LCDInit(void);
void LCDUpdate(void);

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

    // TODO If C++ is being used, regular C code needs function names to have C 
    // linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

