


#include <xc.h>                     //  
#include <string.h>
#include <stdio.h>
#include "LCDBlocking.h"
#include "ds18b20.h"
#define _XTAL_FREQ	4000000         //  

unsigned char LCDTemp[8];
unsigned char Temp[3];


//WDTE =	Watchdog Timer Enable bit
#pragma config WDTE = OFF        // ON	WDT disable
//#pragma config WDTE = ON        // ON	WDT enabled
//PWRTE =	Power-up Timer Enable bit
#pragma config PWRTE = OFF      // OFF	PWRT disable
//#pragma config PWRTE = ON      // OFF	PWRT enabled
//CP =	Flash Program Memory Code Protection bits
#pragma config CP  = OFF         // OFF	Code protection off
//#pragma config CP  = ALL         // OFF	Code protection off
//BOREN =	Brown-out Reset Enable bit
#pragma config BOREN = ON       //ON	Enabled
//DEBUG =	In-Circuit Debugger Mode bit
#pragma config DEBUG = OFF      //OFF	In-Circuit Debugger disabled, RB6 and RB7 are general purpose I/O pins
//LVP =	Low Voltage In-Circuit Serial Programming Enable bit
#pragma config LVP = OFF
//CPD =	Data EE Memory Code Protection
#pragma config CPD = OFF
//#pragma config CPD = ON
//WRT =	FLASH Program Memory Write Enable
#pragma config WRT = OFF
//FOSC =	Oscillator Selection bits
#pragma config FOSC = HS        //HS	HS oscillator


//void LCDWrite(BYTE RS, BYTE Data);
//void LCDInit(void);
//void LCDUpdate(void);







//__EEPROM_DATA(
//0x00, 0x01,         // 
//0x00, 0x00,         //
//0x00, 0x00,         //
//0x00, 0x00);		//
//------------------------------------------------------------------------------



void main(void) 
{
    CLRWDT();	//   
    //unsigned char minus=1;
    //unsigned char ds18b20=23;
    unsigned char ds18b20_error=0;
//  
	//   
	TRISA	= 0b00000001; 	// RA0   
	//PORTA	= 0;
	//   B
	TRISB	= 0b11110000; 	// 
	PORTB	= 0;
	//   C
	TRISC	= 0b00000000;	//
	PORTC	= 0;
	//  , 150 
    //    4 ,1 = 1
    //  1  65536   2
    INTCON =0x00;
    INTCON = _INTCON_GIE_MASK|_INTCON_PEIE_MASK;
    T1CON=0x00;        
    T1CON =_T1CON_TMR1ON_MASK| _T1CON_T1CKPS0_MASK;
    PIE1=0x00;
    PIE1= _PIE1_TMR1IE_MASK ;
	ADCON1 = 0x06;	// Digital I/O
    CONFLAG=0; //   
    
//-----------------------------------------------------------------------------
    CLRWDT();	//   
    ei();	//  
    
    LCDInit();
    //  
    ds18b20_error=init_temp(); // 0  ,1 
    //memset(Temp, ' ', sizeof(Temp)-1);
	//Temp[sizeof(Temp)-1] = 0;
    
    //memset(LCDTemp, ' ', sizeof(LCDTemp)-1);
	//LCDText[sizeof(LCDTemp)-1] = 0;
    
    //strcpy(LCDTemp,'C')
    
    //itoa(Temp, ds18b20, 10);
    //strcat(Temp,'C')
    //strcat(LCDText,Temp);
    //strcat(LCDText,"c");
    //LCDWrite(1, 't');
//------------------------------------------------------------------------------
    while (1)
    {
        CLRWDT();	//   
        if(!ds18b20_error)
        {
            if(minus)
                sprintf(LCDText, "temp=-%dC", ds18b20);
            else
                sprintf(LCDText, "temp=%dC", ds18b20);
        }
        else if(ds18b20_error==3||ds18b20_error==4)
            strcpy(LCDText,"Error ds18b20");
        LCDUpdate();
        __delay_us(50);
        ds18b20_error=Celsio();
    }//  
}//  




//-----------------------------------------------------------------

// 
void interrupt isr(void)
{
    if(TMR1IE&&TMR1IF)
    {
        TMR1IF=0;
        CONV=0;
    }
//----------------------------------------------------------------------------	
}//


